{
<"Object name">, <what this object does>, <version>, <what's unfinished>
Erlend Fjosna 2013
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 <functional description>
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 <acknowledements>.

 Naming convention: Variables starts with: stn: String, int: Integer, flt: Floating point, cmp: Composite, chr: Character, dta: Consecutive bytes containing data sets
                    Constant starts with: stn: String, Cint: Integer, Cflt: Floating point, Ccmp: Composite, Cchr: Character, Cdta: Consecutive bytes containing data sets
                    DAT starts with:           String, Dint: Integer, Dflt: Floating point, Dcmp: Composite, Dchr: Character, Ddta: Consecutive bytes containing data sets
                    PIN constant numbers are: 'intFncPIN' wher Fnc is an abbreviation of the signal/function
                    Reserved words are always in capitals
                    Included objects are called by three letter lower case names
                    Methods (PUB and PRI) have first letter capital then lower case descriptive.
                    Local variables are free text in lower case.

=======================================================================================================================================================================
Hardware & wiring:

Data sheet: <link>

=======================================================================================================================================================================
}

CON
        _clkmode = xtal1 + pll16x                                               'Standard clock mode * crystal frequency = 80 MHz
        _xinfreq = 5_000_000


'Commands and parameters for controlling uOLED-128-G2
'----------------------------------------------------

  intOLEDrstPin         = 18
  intOLEDtxPin          = 19


  CmdOLEDmediaInit      = $FFB1
  CmdOLEDmediaSetSector = $FFB8
  CmdOLEDmediaImage     = $FFB3

  CmpOLEDsdBummerH      = $0000
  CmpOLEDsdBummerL      = $0000
  CmpOLEDsdEyeBeautyH   = $0000
  CmpOLEDsdEyeBeautyL   = $0041
  CmpOLEDsdEyeChameH    = $0000
  CmpOLEDsdEyeChameL    = $0082
  CmpOLEDsdEyeCloseH    = $0000
  CmpOLEDsdEyeCloseL    = $00C3
  CmpOLEDsdEyeDownH     = $0000
  CmpOLEDsdEyeDownL     = $0103
  CmpOLEDsdEyeDown2H    = $0000
  CmpOLEDsdEyeDown2L    = $0144
  CmpOLEDsdEyeDownLeftH = $0000
  CmpOLEDsdEyeDownLeftL = $0185
  CmpOLEDsdEyeDownRightH        = $0000
  CmpOLEDsdEyeDownRightL        = $01C6
  CmpOLEDsdEyeEagleH    = $0000
  CmpOLEDsdEyeEagleL    = $0207
  CmpOLEDsdEyeevilRedH  = $0000
  CmpOLEDsdEyeEvilRedL  = $0248
  CmpOLEDsdEyeHardH     = $0000
  CmpOLEDsdEyeHardL     = $0289
  CmpOLEDsdEyeLeftH     = $0000
  CmpOLEDsdEyeLeftL     = $02CA
  CmpOLEDsdEyeMordorH   = $0000
  CmpOLEDsdEyeMordorL   = $030B
  CmpOLEDsdEyeRightH    = $0000
  CmpOLEDsdEyeRightL    = $034C
  CmpOLEDsdEyeSadLeftH  = $0000
  CmpOLEDsdEyeSadLeftL  = $038D
  CmpOLEDsdEyeSadRightH = $0000
  CmpOLEDsdEyeSadRightL = $03CE
  CmpOLEDsdEyeSharkH    = $0000
  CmpOLEDsdEyeSharkL    = $040F
  CmpOLEDsdEyeSquintH   = $0000
  CmpOLEDsdEyeSquintL   = $0450
  CmpOLEDsdEyeStareH    = $0000
  CmpOLEDsdEyeStareL    = $0491
  CmpOLEDsdEyeUpH       = $0000
  CmpOLEDsdEyeUpL       = $04D2
  CmpOLEDsdEyeUpLeftH   = $0000
  CmpOLEDsdEyeUpLeftL   = $0513
  CmpOLEDsdEyeUpRightH  = $0000
  CmpOLEDsdEyeUpRightL  = $0554
  CmpOLEDsdMummiH       = $0000
  CmpOLEDsdMummiL       = $0595
  CmpOLEDsdPropCapH     = $0000
  CmpOLEDsdPropCapL     = $05D6


VAR
  long    CintBitDurOLED
  byte    strCommand[16]
   
'OBJ


PUB demo
   REPEAT 4
    WAITCNT(2*clkfreq + CNT)
    CintBitDurOLED := clkfreq / 9600
    OLEDsdInit
    OLEDimage(CmpOLEDsdEyeUpLeftH, CmpOLEDsdEyeUpLeftL)
    WAITCNT(clkfreq/2 + CNT)
    OLEDimage(CmpOLEDsdEyeUpH, CmpOLEDsdEyeUpL)
    WAITCNT(clkfreq/2 + CNT)
    OLEDimage(CmpOLEDsdEyeUpRightH, CmpOLEDsdEyeUpRightL)
    WAITCNT(clkfreq/2 + CNT)
    OLEDimage(CmpOLEDsdEyeStareH, CmpOLEDsdEyeStareL)
    WAITCNT(clkfreq/2 + CNT)
    OLEDimage(CmpOLEDsdEyeBeautyH, CmpOLEDsdEyeBeautyL)

  
'------------- OLED specific methods -----------------------

PRI OLEDsdInit
    Tx2bytes(CmdOLEDmediaInit, intOLEDtxPin, CintBitDurOLED)                            'Initialize OLED uSD card
    WAITCNT(clkfreq/5 + CNT)
    'also some code to stop screen saver scrolling


PRI OLEDimage(imageH, imageL)
    Tx2bytes(CmdOLEDmediaSetSector, intOLEDtxPin, CintBitDurOLED)
    Tx2bytes(imageH, intOLEDtxPin, CintBitDurOLED)                                      'set sector address of bitmap
    Tx2bytes(imageL, intOLEDtxPin, CintBitDurOLED)

    Tx2bytes(CmdOLEDmediaImage, intOLEDtxPin, CintBitDurOLED)                           'display bitmap
    Tx2bytes($0000, intOLEDtxPin, CintBitDurOLED)                                       'X-position     
    Tx2bytes($0000, intOLEDtxPin, CintBitDurOLED)                                       'Y-position


'PRI OLEDcontrast(level)
'PRI OLEDtext(string)


'-------------- general purpose tx methods------------------  could move to sep object as PUBs

PRI Tx2bytes(dataword,txPin, bitDur)                    ' Send Word variable to the uOLED display as two bytes, MSB first
    TxB(dataword.BYTE[1],txPin, bitDur)                                           
    TxB(dataword.BYTE[0],txPin, bitDur)
    WAITCNT(clkfreq/100 + CNT)


PRI TxStr(strAddr,txPin, bitDur)
    REPEAT STRSIZE(strAddr)                             ' for each character in string
      TxB(BYTE[strAddr++],txPin, bitDur)                ' write the character


PRI TxB(txByte,txPin, bitDur) | t
    txByte := (txByte | $100) << 1                      ' add start bit, and OR in a stop bit
    OUTA[txPin] :=  1                                   ' idle state
    DIRA[txPin]~~                                       ' 
    t := CNT                                            ' sync
    REPEAT 10                                           ' start + eight data bits + stop
      WAITCNT(t += bitDur)                              ' wait bit duration, first wait keeps 'idle state' for one bit duration
      OUTA[txPin] := txByte                             ' output lsb, 
      txByte >>= 1                                      ' then shift right to move next bit in place for tx


'DAT

{{

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and    
associated documentation files (the "Software"), to deal in the Software without restriction,        
including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense,
and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so,
subject to the following conditions:                                                                 
                                                                                                     
The above copyright notice and this permission notice shall be included in all copies or substantial 
portions of the Software.                                                                            
                                                                                                     
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT
LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  
IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER         
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

}}                                    