{
<"Object name">, <what this object does>, <version>, <what's unfinished>
Erlend Fjosna 2013
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 <functional description>
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
 <acknowledements>.

 Naming convention: Variables starts with: stn: String, int: Integer, flt: Floating point, cmp: Composite, chr: Character, dta: Consecutive bytes containing data sets
                    Constant starts with: stn: String, Cint: Integer, Cflt: Floating point, Ccmp: Composite, Cchr: Character, Cdta: Consecutive bytes containing data sets
                    DAT starts with:           String, Dint: Integer, Dflt: Floating point, Dcmp: Composite, Dchr: Character, Ddta: Consecutive bytes containing data sets
                    PIN constant numbers are: 'intFncPIN' wher Fnc is an abbreviation of the signal/function
                    Reserved words are always in capitals
                    Included objects are called by three letter lower case names
                    Methods (PUB and PRI) have first letter capital then lower case descriptive.
                    Local variables are free text in lower case.

=======================================================================================================================================================================
Hardware & wiring:

Data sheet: <link>

=======================================================================================================================================================================
}

CON
        _clkmode = xtal1 + pll16x                                           
        _clkfreq = 80_000_000

        mSec = _clkfreq / 1000
        uSec = mSec / 1000

        CintBitDurVM2 = _clkfreq / 9600
        

        intVM2txPin           = 12    


VAR

  byte    strCommand[16]
   
'OBJ


PUB demo
     
    VM2play


'------------- VMUSIC2 specific methods --------------------

PRI VM2play                                             'MOD: to take mood & message as arguments

    TxStr(string("VST", 13), intVM2txPin, CintBitDurVM2)
    WAITCNT(clkfreq + CNT)

    TxStr(string("VPF 99_606.MP3", 13), intVM2txPin, CintBitDurVM2)
    WAITCNT(2*clkfreq + CNT)                                         'Have to put in a delay that is at least as long as the play duration

    TxStr(Par2Str(99, 612), intVM2txPin, CintBitDurVM2)


'--------------Parsing of numeric format into string---------------

PRI Par2Str(mood, message) | value      'Convert each digit to ASCII and poke it into the template string
    value := message                                   '612
    BYTEMOVE(@strCommand, STRING("VPF nn_nnn.MP3", 13), 16)

    strCommand[7] := value / 100 + "0"                  '"6"
    value := value - 100*(value / 100)                '612 - 600 = 12
    strCommand[8] := value / 10 + "0"                   '"1"
    value := value - 10*(value / 10)                  '12 - 10 = 2
    strCommand[9] := value + "0"                        '"2"

    value := mood                                      '99
    strCommand[4] := value / 10 + "0"                  '"9"
    value := value - 10*(value / 10)                  '99 - 90 = 9
    strCommand[5] := value + "0"                       '"9"                    

    return @strCommand


'-------------- general purpose tx methods------------------  could move to sep object as PUBs

PRI Tx2bytes(dataword,txPin, bitDur)                    ' Send Word variable as two bytes, MSB first
    TxB(dataword.BYTE[1],txPin, bitDur)                                           
    TxB(dataword.BYTE[0],txPin, bitDur)
    WAITCNT(clkfreq/100 + CNT)


PRI TxStr(strAddr,txPin, bitDur)
    REPEAT STRSIZE(strAddr)                             ' for each character in string
      TxB(BYTE[strAddr++],txPin, bitDur)                ' write the character


PRI TxB(txByte,txPin, bitDur) | t
    txByte := (txByte | $100) << 1                      ' add start bit, and OR in a stop bit
    OUTA[txPin] :=  1                                   ' idle state
    DIRA[txPin]~~                                       ' 
    t := CNT                                            ' sync
    REPEAT 10                                           ' start + eight data bits + stop
      WAITCNT(t += bitDur)                              ' wait bit duration, first wait keeps 'idle state' for one bit duration
      OUTA[txPin] := txByte                             ' output lsb, 
      txByte >>= 1                                      ' then shift right to move next bit in place for tx


'DAT

{{

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and    
associated documentation files (the "Software"), to deal in the Software without restriction,        
including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense,
and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so,
subject to the following conditions:                                                                 
                                                                                                     
The above copyright notice and this permission notice shall be included in all copies or substantial 
portions of the Software.                                                                            
                                                                                                     
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT
LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  
IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER         
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

}}                                    